
local craft = g_ui.displayUI("itemscraft")
local panelInfo = craft:getChildById("panelcategory")
local panelitemscraft = craft:getChildById("panelitemscraft")
local panelitemsinfo = craft:getChildById("panelitemsinfo")
local searchItem = craft:getChildById("searchItem")
local buttoncraft = craft:getChildById("buttoncraft")
local scrollbar = craft:getChildById("countScrollBar")
local textCount = craft:getChildById("textcount")
local PercentItem = craft:getChildById("progress")
local categorylist = craft:getChildById("categorylist")
local item_UIWidget = craft:getChildById("itemiduiwidget")
local money_uiwidget = craft:getChildById("money_uiwidget")

--OPCODE
local OPCODESENDINFO_craft = 135 -- opcode para abrir a janela do module com apenas as categorias carregada.
local OPCODEDESTROYINFO = 136 -- opcode para destruir as informaes do module para recriar outras novamente.
local ONSENDOPCODE_CRAFTITEMS = 138 -- opcode para receber os items que podem ser craftado.
local ONSENDINFOITEMCRAFT = 140 -- opcode para receber as informaes dos itens.

--OPCODE enviar para o servidor
local OPCODESENDINFOCraft = 137 -- opcode para enviar para o servidor que o jogador escolheu a categoria desejada.
local OPCODESENDINFOITEMCRAFT = 139 -- opcode para enviar para o servidor que o jogador escolheu o item que quer craftar.
local ONSEARCHITEM = 141 -- opcode enviando para o servido para o jogador procurar um item.
local SENDCRAFTBUTTON = 142

--UIWidget
local iteminfo = nil
local progressWidgets = {}
local categories = {}
local selectcategory = false
local defaultcategory = "Todos"
local selecitemcraft = false
local changecategory =  false -- boto para adicionar um delay para trocar de categoria, "helments, armors etc..."
local recebevalue = nil

function init()
    connect(g_game, {
        onGameStart = naoexibir,
        onGameEnd = naoexibir,
    })
    connect(LocalPlayer, { onPositionChange = onPositionChange })

    craft:hide()
    ProtocolGame.registerExtendedOpcode(ONSENDINFOITEMCRAFT, function(protocol, opcode, buffer) onReceiveItemsInfo(buffer) end)
    ProtocolGame.registerExtendedOpcode(ONSENDOPCODE_CRAFTITEMS, function(protocol, opcode, buffer) onReceiveItemsCategory(buffer) end)
    ProtocolGame.registerExtendedOpcode(OPCODESENDINFO_craft, function(protocol, opcode, buffer) onReceivecraft(buffer) end)
    ProtocolGame.registerExtendedOpcode(OPCODEDESTROYINFO, function(protocol, opcode, buffer) onReceiveDestroyInfo(buffer) end)
end

function terminate()
    disconnect(g_game, {
        onGameStart = naoexibir,
        onGameEnd = naoexibir,
    })
    disconnect(Creature, { onPositionChange = onPositionChange })

    ProtocolGame.unregisterExtendedOpcode(ONSENDINFOITEMCRAFT)
    ProtocolGame.unregisterExtendedOpcode(ONSENDOPCODE_CRAFTITEMS)
    ProtocolGame.unregisterExtendedOpcode(OPCODESENDINFO_craft)
    ProtocolGame.unregisterExtendedOpcode(OPCODEDESTROYINFO)

    craft:hide()
end

function onPositionChange(creature, newPos, oldPos)
    if creature:isLocalPlayer() and craft:isVisible() then
        naoexibir()
    end
end

function exibir()
    if craft:isVisible() then
        naoexibir()
    else
        craft:show()
    end
end

function naoexibir()
    craft:hide()
    if panelitemsinfo then
        panelitemsinfo:destroyChildren()
    end

    if panelitemscraft then
        panelitemscraft:destroyChildren()
        searchItem:setVisible(false)
        buttoncraft:setVisible(false)
    end

    if item_UIWidget then
        item_UIWidget:setVisible(false)
    end

    if money_uiwidget then
        money_uiwidget:setVisible(false)
    end

    if selecitemcraft then
        selecitemcraft = false
    end

    if selectcategory then
        selectcategory = false
    end

    if changecategory then
        changecategory = false
    end

    if searchItem then
        searchItem:clearText()
    end

    onClearScrollViewCount()
    categorylist:clearOptions()
end

function onReceiveDestroyInfo(buffer)
    local param = buffer:split("@")
    local type = tostring(param[1])

    if type == "destroy" then
        onClearScrollViewCount()      
    end

    if type == "itemcraft" then
        panelitemscraft:destroyChildren()
        onClearScrollViewCount()
        if panelitemsinfo then
            item_UIWidget:setVisible(false)
            panelitemsinfo:destroyChildren()
            buttoncraft:setVisible(false)
            textCount:clearText()
            money_uiwidget:clearText()
        end
    end

    if type == "item" then
        panelitemsinfo:destroyChildren()
    end

    if selectcategory then
        selectcategory = false
    end

end

function onReceivecraft(buffer)
    local param = buffer:split("@")
    local category = tostring(param[1])
    local money = tonumber(param[2])
	
	exibir()
    category = category:sub(1, -2)
    local _categorys = string.explode(category, ";")
    table.insert(_categorys, 1, "Todos")
    
    buttoncraft:setVisible(false)
    local balance = craft:getChildById("balance")
    balance:setText(formatNumberWithCommas(money))
    balance:setTooltip("Balance atual: "..formatNumberWithCommas(money))

    for i = 1, #_categorys do
        categorylist.onOptionChange = nil
        categorylist:addOption(_categorys[i])
    end

    categorylist.onOptionChange = function(widget)
        if not changecategory then -- adicionar um delay de 1.5 segundos para o jogador conseguir trocar de categoria.
            changecategory = true
            categorylist:setEnabled(false)
            local selectedCategory = widget:getCurrentOption().text
            g_game.getProtocolGame():sendExtendedOpcode(OPCODESENDINFOCraft, selectedCategory.."@")
            panelitemsinfo:destroyChildren()

            scheduleEvent(function() 
                categorylist:setEnabled(true)
                changecategory = false
            end, 1500)
        end
    end 

    if not selectcategory then -- sempre que abrir o module, a categoria default ser selecionada.
        selectcategory = true
        g_game.getProtocolGame():sendExtendedOpcode(OPCODESENDINFOCraft, defaultcategory.."@")
    end
end

function onReceiveItemsCategory(buffer)
    local param = buffer:split("@")
    local category = tostring(param[1])
    local subcategory = tonumber(param[2])
    local itemid = tonumber(param[3])
    local name = tostring(param[4])
    local info = tostring(param[5])
            
    buttoncraft:setVisible(false) -- fechar o boto de craftar caso ele tenha clicado nas categoria

    local sub_category = g_ui.createWidget("UIItem", panelitemscraft)
    sub_category:setImageSource("window/slotitem")
    sub_category:setSize("70 70")

    local item_category = g_ui.createWidget("UIItem", sub_category)
    item_category:addAnchor(AnchorTop, "parent", AnchorTop)
    item_category:addAnchor(AnchorHorizontalCenter, "parent", AnchorHorizontalCenter)
    item_category:setMarginTop(7)
    item_category:setItemId(itemid)
    item_category:setTooltip(name.."\n"..info)
    item_category:setSize("45 45")
    item_category.onClick = function()
        if not selecitemcraft then -- usado para setar um tempo de 2 segundos para o jogador clicar em outro item novamente.
            selecitemcraft = true 
            g_game.getProtocolGame():sendExtendedOpcode(OPCODESENDINFOITEMCRAFT, category.."@"..subcategory.."@")

            scheduleEvent(function()
                item_UIWidget:setVisible(true)
                money_uiwidget:setVisible(true)
            end, 200)

            scheduleEvent(function()
                selecitemcraft = false
            end, 200)
        end
    end

    searchItem:setVisible(true)
    searchItem:setTextOffset("0 -5")
    searchItem.onTextChange = function(self, value) -- search
        if value == "" or value == nil then
            g_game.getProtocolGame():sendExtendedOpcode(OPCODESENDINFOCraft, category.."@") -- enviando um novo opcode caso o jogador tenha pesquisado algo e deletou todo o texto.
            return
        end

        if panelitemsinfo then -- verificando se o jogador ja clicou em algum item, para resetar todos os valores quando ele tentar procurar algum novo item na lista.
            item_UIWidget:setVisible(false)
            panelitemsinfo:destroyChildren()
            buttoncraft:setVisible(false)
            textCount:clearText()
            money_uiwidget:clearText()
        end

        g_game.getProtocolGame():sendExtendedOpcode(ONSEARCHITEM, category.."@"..value.."@".."craft".."@")
    end

end

function onReceiveItemsInfo(buffer)
    local param = buffer:split("@")
    local itemid = tonumber(param[1])
    local ingredientes = tonumber(param[2])
    local ingredientes_count = tonumber(param[3])
    local money = tonumber(param[4])
    local category = tostring(param[5])
    local subcategory = tonumber(param[6])
    local getItemPlayerCount = tonumber(param[7])
    local playerMoney = tonumber(param[8])
    local clientItemID = tonumber(param[9])
    local nameItem = tostring(param[10])
	local itemMaxCount = tonumber(param[11])

    item_UIWidget:setItemId(clientItemID)

    money_uiwidget:setText(formatNumberWithCommas(money))
    money_uiwidget:setTooltip("Quantidade de moedas necessria: "..formatNumberWithCommas(money).." voc tem "..formatNumberWithCommas(playerMoney)..".")
 
    iteminfo = g_ui.createWidget("UIItem", panelitemsinfo)
    iteminfo:setSize("50 50")
    iteminfo:setFont("sans-bold-16px")
    iteminfo:setItemId(ingredientes)
    iteminfo:setTooltip(nameItem)

    local progressPercent = g_ui.createWidget("ProgressBar", iteminfo)
    local percent = math.floor(getItemPlayerCount / ingredientes_count * 100)
    progressPercent:setPercent(percent)
    progressPercent:setSize("50 15")
    progressPercent:setMarginBottom(0)
    progressPercent:addAnchor(AnchorBottom, "parent", AnchorBottom)
    progressPercent:addAnchor(AnchorHorizontalCenter, "parent", AnchorHorizontalCenter)
    progressPercent:setBackgroundColor("green")
    progressPercent:setText(getItemPlayerCount.." / "..ingredientes_count)
    --progressPercent:setTextAutoResize("true")
    progressPercent:setWidth(50)

    if ingredientes_count then
        progressPercent.ingredientesCount = ingredientes_count
        progressPercent.getCount = getItemPlayerCount
		progressPercent.max = getItemPlayerCount / ingredientes_count
    end
  
    table.insert(progressWidgets, progressPercent)

    scrollbar:setVisible(true)
	if itemMaxCount == 0 then
		buttoncraft:setEnabled(false)
		scrollbar:setRange(0, 0) -- quantidade entre 1 a 100
	else
		scrollbar:setRange(1, 100)
		buttoncraft:setEnabled(true)
	end
	
	scrollbar:setValue(itemMaxCount)
    textCount:setText(itemMaxCount)
    textCount:setTextAutoResize("true")
    textCount:setFont("sans-bold-16px")
    buttoncraft:setVisible(true)
	
    scrollbar.onValueChange = function(widget, value)
        textCount:setText(value)
        textCount:setTextAutoResize("true")
        textCount:setFont("sans-bold-16px")
		local maximunValue = {}
		
        for _, v in ipairs(progressWidgets) do
            if v.ingredientesCount and v.getCount and v.max then
                v:setText(v.getCount.." / "..v.ingredientesCount * value)
                local calculo = v.ingredientesCount * value
                v:setPercent(v.getCount / calculo * 100)
				
				if v.max == 0 then
					v:setBackgroundColor("alpha")
				end
				
				table.insert(maximunValue, v.max)
            end
        end
		
		local lowerNumber = maximunValue[1]
		for i = 1, #maximunValue do
			if maximunValue[i] < lowerNumber then
				lowerNumber = maximunValue[i]
			end
		end
		
		widget:setMaximum(lowerNumber)

        money_uiwidget:setText(formatNumberWithCommas(money * value))
        money_uiwidget:setTooltip("Quantidade de moedas necessria: "..formatNumberWithCommas(money * value).." voc tem "..formatNumberWithCommas(playerMoney).."")
    end

    buttoncraft.onClick = function() -- boto para enviar que o jogador clicou em CRAFT
        local value = scrollbar:getValue()
        g_game.getProtocolGame():sendExtendedOpcode(SENDCRAFTBUTTON, category.."@"..subcategory.."@"..itemid.."@"..value.."@")
    end
    
end


function onClearScrollViewCount()
    textCount:clearText()
    scrollbar:setVisible(false)
end

function formatNumberWithCommas(value)
    local kb = math.floor(value / 1024)
    return tostring(kb) .. "K"
end

function formatNumberWithCommas(number)
    local formatted = tostring(number)
    local k
    while true do
        formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1.%2')
        if k == 0 then
            break
        end
    end
    return formatted
end